// DisplayName = Chaser - Team Aerial Combat

//--- GAME RULES BEGIN ---
//Protect your team's Chaser Bike
//Destroy the enemy team's Chaser Bike
//Chaser cannot tell friend from foe.
//Chaser may not leave the mission area.
//Chaser cannot use any communication
//Dont touch the ground...it hurts.
//--- GAME RULES END ---


//=====================================================================================
//	TAC2 - Chaser Mission Code								Wizard_TPG - 11/5/2001
//
//	This code includes:
//				Chaser Game Code
//				Player spawns with repair pack
//
//=====================================================================================


//exec the AI scripts
exec("scripts/aiCTF.cs");


//-- tracking  ---
// .deaths .kills .genDefends .carrierKills .flagDefends .escortAssists .suicides .teamKills .turretKills .flagCaps
// .flagReturns .genDestroys .genRepairs

function TAC_ChaserGame::initGameVars(%game)
{
	%game.SCORE_PER_VEHICLE_APC_KILL = 3;  	//enemy team gets this for killing your apc from a vehicle
	%game.SCORE_PER_OTHER_APC_KILL = 1;		//enemy team gets this for killing apc otherwise
	%game.SCORE_PER_OWN_APC_KILL = -3;		//Your team gets this if you tk an apc
	%game.SCORE_PER_BASE_APC_KILL = 0;		//Enemy team gets this if your veihcle is destroyed by enemy base turrets
	%game.SCORE_PER_TURRET_APC_KILL = 1;	//Enemy team gets this for kills by other turrets
	%game.SCORE_PER_CRASH_APC_KILL = -1;	//Your team gets this if you crash an apc
	%game.SCORE_PER_COLLIDE_APC_KILL = 1;	//Your team gets this if you collide with an enemy causing their vehicle to be destroyed
	%game.SCORE_PER_CHASER_KILL = 25;

	%game.SCORE_PER_SUICIDE = 0;
	%game.SCORE_PER_TEAMKILL = 0;
	%game.SCORE_PER_DEATH = 0;

	%game.SCORE_PER_KILL = 0;
	%game.SCORE_PER_PLYR_FLAG_CAP = 0;
	%game.SCORE_PER_TEAM_FLAG_CAP = 10;
	%game.SCORE_PER_GEN_DESTROY = 0;
	%game.SCORE_PER_ESCORT_ASSIST = 0;

	%game.SCORE_PER_TURRET_KILL = 0;
	%game.SCORE_PER_FLAG_DEFEND = 0;
	%game.SCORE_PER_CARRIER_KILL = 0;
	%game.SCORE_PER_FLAG_RETURN = 0;
	%game.SCORE_PER_GEN_DEFEND = 0;
	%game.SCORE_PER_GEN_REPAIR = 0;

	%game.FLAG_RETURN_DELAY = 15 * 1000;

	%game.TIME_CONSIDERED_FLAGCARRIER_THREAT = 0;  //after damaging enemy flag carrier
	%game.RADIUS_GEN_DEFENSE = 0;  //meters
	%game.RADIUS_FLAG_DEFENSE = 0;  //meters

	%game.fadeTimeMS = 2000;
	%game.notifyMineDist = 7.5;
}

//--------------------------------------------------------------------------------------------------------------------

function TAC_ChaserGame::missionLoadDone(%game)
{
	%game.numTeams = 4;
   	DefaultGame::missionLoadDone(%game);
}


function TAC_ChaserGame::setUpTeams(%game)
{
	DefaultGame::setUpTeams(%game);

	%game.ReColourTeams();

	for(%team = 3;%team < 5;%team++)
	{
	   	//Setup Team Names and skins...hopefully
	   	%fteam = %team == 3 ? 1 : 2;
		$OldteamName[%team] = $teamName[%team];
		$OldteamSkin[%team] = $teamSkin[%team];
		$teamName[%team] = getTaggedString($teamName[%fteam]) @ " Chaser";
		$teamSkin[%team] = getTaggedString($teamSkin[%fteam]);
		$teamName[%team] = addTaggedString($teamName[%team]);
		$teamSkin[%team] = addTaggedString($teamSkin[%team]);

	   	//spawn chaser bikes
	   	%game.CreateChaserBike(%team);
	}
}


function TAC_ChaserGame::CreateChaserBike(%game, %team)
{
	%spawnLoc = %game.pickTeamSpawn(%team);
	if(%spawnloc == -1)
		%spawnLoc = %game.pickTeamSpawn(%team);
	if(%spawnloc == -1)
		error("Chaser Bike for Team ",%team," did not spawn!");

	%chaserbike = ScoutVehicle.create(%team);
	for(%loc = 0;%loc<7;%loc++)
	{
		%locdata[%loc] = getword(%spawnLoc,%loc);
		if(%loc == 2)
			%locdata[%loc]+=10;
		if(%loc == 0)
			%outputloc = %locdata[%loc];
		else
			%outputloc = %outputloc @ " " @ %locdata[%loc];
	}
	%chaserbike.setTransform( %outputloc );
	%chaserbike.chaser = true;
	$ChaserBikeID[%team] = %chaserbike;
	setTargetSensorGroup(%chaserbike.getTarget(), %team);
}

function TAC_ChaserGame::RespawnChaserBike(%game, %team)
{
	%game.CreateChaserBike(%team);
	MessageAll('msgChaserRespawn', '\c0The %1s Chaser Bike has respawned.',$teamName[%team]);
}

function TAC_ChaserGame::equip(%game, %player)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);

   if(%player.team < 3)
   {
	   %player.setInventory(RepairKit,1);
	   %player.setInventory(FlareGrenade,6);
	   %player.setInventory(Blaster,1);
	   %player.setInventory(Chaingun,1);
	   %player.setInventory(ChaingunAmmo, 100);
	   %player.setInventory(Disc,1);
	   %player.setInventory(DiscAmmo, 20);
	   %player.setInventory(RepairPack,1);
	   %player.setInventory(TargetingLaser, 1);
	   %player.weaponCount = 3;
	   %player.use("Blaster");
   }
   else
   {
	   %player.setInventory(RepairKit,1);
	   %player.setInventory(RepairPack,1);
	   %player.setInventory(Blaster,1);
	   %player.weaponCount = 3;
	   %player.use("Blaster");
   }
}

function TAC_ChaserGame::VehicleKill(%game, %data, %obj)
{
	DefaultGame::VehicleKill(%game, %data, %obj);
}

function TAC_ChaserGame::timeLimitReached(%game)
{
	echo("LOG: game over (timelimit)");
	%game.gameOver();
   schedule( 5000, %game, cycleMissions );
}

function TAC_ChaserGame::scoreLimitReached(%game)
{
	echo("LOG: game over (scorelimit)");
	%game.gameOver();
   schedule( 5000, %game, cycleMissions );
}

function TAC_ChaserGame::gameOver(%game)
{
	//send the winner message
	%winner = "";
	if ($teamScore[1] > $teamScore[2])
		%winner = $teamName[1];
	else if ($teamScore[2] > $teamScore[1])
		%winner = $teamName[2];

	if (%winner $= 'Storm')
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.stowins.wav" );
	else if (%winner $= 'Inferno')
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.infwins.wav" );
	else
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );

	//call the default
	DefaultGame::gameOver(%game);

   %game.sendDebriefing();
	messageAll('MsgClearObjHud', "");
	for(%team = 3;%team < 5;%team++)
	{
	   	//Change Back Team Names and skins
		$teamName[%team] = $OldteamName[%team];
		$teamSkin[%team] = $OldteamSkin[%team];
	}
	$ChaserBikeID[3] = "";
	$ChaserBikeID[4] = "";
	for(%i = 0; %i < ClientGroup.getCount(); %i ++)
	{
		%client.chaser = false;
		%client.player.chaser = false;
		if(%client.team > 3)
		{
			%team = %client.team == 3 ? 1 : 2;
			%game.clientChangeTeam(%client, %team);
		}
		%client = %group.getObject(%i);
		%game.resetScore(%client);
	}
   for(%j = 1; %j <= %game.numTeams; %j++)
		$TeamScore[%j] = 0;


}


////////////////////////////////////////////////////////////////////////////////////////
function TAC_ChaserGame::clientMissionDropReady(%game, %client)
{
   messageClient(%client, 'MsgClientReady',"", %game.class);

   for(%i = 1; %i <= %game.numTeams; %i++)
   {
      messageClient(%client, 'MsgChaserAddTeam', "", %i, $TeamName[%i], $TeamScore[%i]);
   }

	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );

	DefaultGame::clientMissionDropReady(%game, %client);
}


function TAC_ChaserGame::assignClientTeam(%game, %client, %respawn)
{
	DefaultGame::assignClientTeam(%game, %client, %respawn);
	// if player's team is not on top of objective hud, switch lines
	if(%client.team > 2)
		%client.chaser = true;
	else
		%client.chaser = false;
	messageClient(%client, 'MsgCheckTeamLines', "", %client.team);
}

function TAC_ChaserGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement)
{
	if(%clKiller <= 0 || %clKiller $= "")
	{
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testKill(%clVictim, %clKiller)) //verify victim was an enemy
	{
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else
	{
		if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		{
			%game.awardScoreSuicide(%clVictim);
		}
		else
		{
			if (%game.testTeamKill(%clVictim, %clKiller)) //otherwise test for a teamkill
				%game.awardScoreTeamKill(%clVictim, %clKiller);
		}
	}
}

function TAC_ChaserGame::checkScoreLimit(%game, %team)
{
	echo("*** current score = ",$TeamScore[1]," - ",$TeamScore[2]);
	%scoreLimit = MissionGroup.TAC_Chaser_scoreLimit;
	if(%scorelimit $= "")
		%scoreLimit = 150;
	if(%team > 2)
	{
		%mainteam = %team == 3 ? 1 : 2;
		$TeamScore[%mainteam] += $TeamScore[%team];
		$TeamScore[%team] = 0;
		%team = %mainteam;
	}
   	if($TeamScore[%team] >= %scoreLimit)
      	%game.scoreLimitReached();
}


//Check if chaser is needed on "Group" team
function TAC_ChaserGame::ChaserRequired( %game, %team )
{
	//Get number of players on each team
	%game.numTeams = %game.numTeams $= "" ? 4 : %game.numTeams;
	for(%i = 0; %i <= %game.numTeams; %i++)
	  	%numTeamPlayers[%i] = 0;
	%numPlayers = ClientGroup.getCount();
	for(%i = 0; %i < %numPlayers; %i++)
	{
	  	%cl = ClientGroup.getObject(%i);
	  	%numTeamPlayers[%cl.team]++;
	}

	//Check if chasers required
	if(%team < 3)
	{
		%friendlyteam = %team == 1 ? 3 : 4;
		if(%numTeamPlayers[%friendlyteam] == 0)
			return true;
	}
	else
		if(%numTeamPlayers[%team] == 0)
			return true;

	return false;
}

function TAC_ChaserGame::respawnChaserPlayer(%game, %client)
{
	commandToClient(%client, 'setHudMode', 'Standard');
	%client.chaser = true;
	%chaserbike = $ChaserBikeID[%client.team];
	if(!isObject(%chaserbike))
	{
		error("*** Chaser Bike Did Not Exist - Spawning New One ***");
		%game.CreateChaserBike(%client.team);
		%chaserbike = $ChaserBikeID[%client.team];
	}

	%player = %client.player;
	if(isObject(%player))
	{
		%game.teamChaserPlayer[%client.team] = %player;
		%game.teamChaserClient[%client.team] = %client;
		%player.chaser = true;
		%node = 0;
		%chaserbike.abandon = false;
		%player.getDataBlock().onCollision(%player, %chaserbike, 0);
		messageClient(%client, 'ChaserAdvise', '\c1You are the chaser! The enemy team is trying to destroy your bike. Dont let them!');
	}
	else
	{
		error("No Player to Transform on to bike!");
		%game.createPlayer(%client, %outputloc, false);
	}
}


function TAC_ChaserGame::createPlayer(%game, %client, %spawnLoc, %respawn)
{
	if(%client.team == 0)
	  	error("Players should not be added to team0!");
	if( %client.player > 0 )
	  	error( "Attempting to create an angus ghost!" );
	if(%spawnLoc == -1)
	  	%spawnLoc = "0 0 300 1 0 0 0";

	if (%client.race $= "Bioderm")
	  	%armor = $DefaultPlayerArmor @ "Male" @ %client.race @ Armor;
	else
	  	%armor = $DefaultPlayerArmor @ %client.sex @ %client.race @ Armor;
	%client.armor = $DefaultPlayerArmor;

	//Check if chaser exists and if not....force player to chaser
	%team = %client.team;
	if(%game.ChaserRequired( %team ) && %team > 0 && %team < 3 && $matchStarted)
	{
		if(!$Host::TournamentMode)
		{
			if(!%game.isChaserVote[%team])
				%game.StartGetRiderList(%team);
		}
	}

	%player = new Player()
	{
	  	dataBlock = %armor;
	};

	if(%respawn && %client.team < 3)
	{
		%player.setInvincible(true);
		%player.setCloaked(true);
		%player.setInvincibleMode($InvincibleTime,0.02);
		%player.respawnCloakThread = %player.schedule($InvincibleTime * 1000, "setRespawnCloakOff");
		%player.schedule($InvincibleTime * 1000, "setInvincible", false);
	}

	// setup some info
	%player.setOwnerClient(%client);
	%player.team = %client.team;
	%client.outOfBounds = false;
	%player.setEnergyLevel(60);
	%client.player = %player;
	MissionCleanup.add(%player);

	if(%client.team < 3)
	{
		%client.chaser = false;
		%player.chaser = false;
		%player.setTransform( %spawnLoc );
	}
	else
	{
		%game.respawnChaserPlayer(%client);
		%client.chaser = true;
		%client.player.chaser = true;
	}

	%game.ReColourTeams(%client);

	//make sure the player has been added to the team rank array...
	%game.populateTeamRankArray(%client);

	%game.playerSpawned(%client.player);
}


//Prevent Chaser from changing teams
function TAC_ChaserGame::clientChangeTeam(%game, %client, %team, %fromObs)
{
	if(%client.team > 2)
	{
	   	messageClient(%client, 'NoChangeTeam', '\c1You are the chaser and may not change teams.');
		return;
	}
	if(%team > 2 && !%game.ChaserRequired( %team ))
	{
	   	messageClient(%client, 'NoChangeTeam', '\c1There can only be one chaser per team.');
	   	%team = %team == 3 ? 1 : 2;
	   	%game.clientChangeTeam(%client, %team, %fromObs);
	   	return;
	}
	DefaultGame::clientChangeTeam(%game, %client, %team, %fromObs);
}

function TAC_ChaserGame::onClientEnterObserverMode( %game, %client )
{
	%client.chaser = false;
}

function TAC_ChaserGame::enterMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
	return;

   %player.client.outOfBounds = false;
   messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
   logEcho(%player.client.nameBase@" (pl "@%player@"/cl "@%player.client@") entered mission area");
   cancel(%player.alertThread);
}

function TAC_ChaserGame::leaveMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
	return;

   if(%player.client.team < 3)
   		return;
   %player.client.outOfBounds = true;
   messageClient(%player.client, 'LeaveMissionArea', '\c1You have left the mission area. Return or take damage.~wfx/misc/warning_beep.wav');
   logEcho(%player.client.nameBase@" (pl "@%player@"/cl "@%player.client@") left mission area");
   %player.alertThread = %game.schedule(1000, "DMAlertPlayer", 3, %player);
}

function TAC_ChaserGame::DMAlertPlayer(%game, %count, %player)
{
   // MES - I commented below line out because it prints a blank line to chat window
   //messageClient(%player.client, 'MsgDMLeftMisAreaWarn', '~wfx/misc/red_alert.wav');
   if(%count > 1)
      %player.alertThread = %game.schedule(1000, "DMAlertPlayer", %count - 1, %player);
   else
      %player.alertThread = %game.schedule(1000, "MissionAreaDamage", %player);
}

function TAC_ChaserGame::MissionAreaDamage(%game, %player)
{
   if(%player.getState() !$= "Dead")
   {
      %player.setDamageFlash(0.1);
      %prevHurt = %player.getDamageLevel();
      %player.setDamageLevel(%prevHurt + 0.05);
      %player.alertThread = %game.schedule(1000, "MissionAreaDamage", %player);
   }
   else
      %game.onClientKilled(%player.client, 0, $DamageType::OutOfBounds);
}


function TAC_ChaserGame::ReColourTeams(%game, %client)
{
	//Reset bike teams
	if(isObject($ChaserBikeID[3]))
	{
		%chaser = $ChaserBikeID[3];
		%chaser.team = 3;
	}
	if(isObject($ChaserBikeID[4]))
	{
		%chaser = $ChaserBikeID[4];
		%chaser.team = 4;
	}

	//Set friendly chaser as green sensor group colours
	for (%setteam = 1; %setteam < 3; %setteam++)
	{
      	%greenMask = 0;
		%friendlychaser = %setteam == 1 ? 3 : 4;
		%greenMask |= (1 << %friendlychaser);
	   	setSensorGroupColor(%setteam, %greenMask, "0 255 0 255"); //green
   	}

	if(%client)
	{
		%player = %client.player;
		%player.setTarget(%client.target);
		setTargetDataBlock(%client.target, %player.getDatablock());
		setTargetSensorData(%client.target, PlayerSensor);
		setTargetSensorGroup(%client.target, %client.team);
		%client.setSensorGroup(%client.team);
	}
}

function TAC_ChaserGame::DisplaySpecialDebriefMessage(%game, %client)
{
	messageClient( %client, 'MsgDebriefResult', "", '<just:center>Team %1 wins because %2s Chaser Bike was destroyed!', $TeamName[%firstTeam], $TeamName[%secondTeam] );
}

function TAC_ChaserGame::DisplaySpecialTeamScore(%game, %client, %score)
{
	%score -= %game.SCORE_PER_CHASER_KILL;
	messageClient( %client, 'MsgDebriefAddLine', "", '<tab:5,155><clip:150>\t%1</clip>\t%2 + Chaser Destroyed', $TeamName[%team], %score );
}

function TAC_ChaserGame::startMatch(%game)
{
	DefaultGame::startMatch(%game);


	if(!$Host::TournamentMode)
	{
		%game.StartGetRiderList(3);
	}
	if(!$Host::TournamentMode)
	{
		%game.StartGetRiderList(4);
	}
}

function TAC_ChaserGame::StartGetRiderList(%game, %team)
{
	%numPlayers = ClientGroup.getCount();
	for(%i = 0; %i < %numPlayers; %i = %i + 1)
	{
	  	%client = ClientGroup.getObject(%i);
		if(%client.team == %team)
		{
			%client.chaservote = false;
			%game.isChaserVote = true;
			messageClient( %client, 'VoteStarted', '\c2Your team needs a Chaser.  Do you wanna ride?');
			if(%team == 1)
			{
				%game.isChaserVote[1]=true;
				serverCmdStartNewVote(0, "ChaserNeeded1");
			}
			else
			{
				%game.isChaserVote[2]=true;
				serverCmdStartNewVote(0, "ChaserNeeded2");
			}
		}
	}
}

function TAC_ChaserGame::SelectNextChaser(%game, %chaserteam)
{
   	%team = %chaserteam == 3 ? 1 : 2;
   	%game.isChaserVote[%team]=false;
   	%game.isChaserVote = false;

	if(!%game.ChaserRequired( %team ))
		return;

	%numPlayers = ClientGroup.getCount();
	%playerid = 0;
	for(%i = 0; %i < %numPlayers; %i = %i + 1)
	{
	  	%client = ClientGroup.getObject(%i);
	  	if(%client.team == %chaserteam)
	  	{
			if(%client.chaservote)
			{
				%playerid++;
				%playerlist[%playerid] = %client;
			}
		}
	}
	if(%playerid <= 0 )
		return;

	%randSum = mfloor(getRandom() + 0.5);
	%randSum = %randSum <= 0 ? 1 : %randSum;
	%randSum = %randSum > %playerid ? %playerid : %randSum;

	%client = %playerlist[%randSum];

	%team = %client.team == 1 ? 3 : 4;
	%client.chaser = true;
	%game.clientChangeTeam(%client, %team, false);
	return;
}

function TAC_ChaserGame::getChaserBikeID(%game, %team)
{
	if(%team == 1)
		%team = 3;
	if(%team == 2)
		%team = 4;
	return $ChaserBikeID[%team];
}