//	TAC2 Emplacement Cannon

datablock TurretData(EmplacementBase) : TurretDamageProfile
{
   className      = TurretBase;
   catagory       = "Turrets";
   shapeFile      = "turret_base_large.dts";
   preload        = true;
   mass           = 1.0;
   emap = true;

   maxEnergy = 150;
   rechargeRate = 0.31;
   humSound = SensorHumSound;
   pausePowerThread = true;
};

datablock TurretData(EmplacementTurret) : TurretDamageProfile
{
	className      		= VehicleTurret;
	catagory       		= "Turrets";
	shapeFile      		= "Turret_tank_base.dts";
	preload        		= true;

	mass           		= 1.0;  // Not really relevant

	mountoffset 		= "-5 0 2.65";
	offset			= "-5 0 2.65";
	spawnOffset 		= "-5 0 2.65";

	lightOnly = 1;
	mountPose[0] = sitting;
	numMountPoints = 1;
	isProtectedMountPoint[0] = false;

	maxEnergy      		= 1;
	maxDamage      		= MobileGunPlatformVehicle.maxDamage;
	destroyedLevel 		= MobileGunPlatformVehicle.destroyedLevel;
	repairRate     		= 0;

	thetaMin 		= 20;
	thetaMax 		= 95;

	inheritEnergyFromMount 	= true;
	firstPersonOnly 	= true;
	useEyePoint 		= true;
	numWeapons 		= 1;

	scale			= "1 1 1.50";

	cameraDefaultFov 	= 90.0;
	cameraMinFov 		= 5.0;
	cameraMaxFov 		= 120.0;

	targetNameTag 	= 'Beowulf Chaingun';
	targetTypeTag 	= 'Turret';
};


//================================================================================
// Projectile and explosion data

datablock ShockwaveData(EMPMortarShockwave)
{
	width = 20.0;
	numSegments = 32;
	numVertSegments = 12;
	velocity = 12;
	acceleration = 55.0;
	lifetimeMS = 650;
	height = 2.5;
	verticalCurve = 1.5;
	is2D = false;

	texture[0] = "special/ELFBeam";
	texture[1] = "special/shockwave4";
	texWrap = 2.0;

	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	colors[0] = "0.3 0.3 0.9 0.95";
	colors[1] = "0.5 0.5 0.5 0.65";
	colors[2] = "0.6 0.6 0.9 0.35";

	mapToTerrain = true;
	orientToNormal = false;
	renderBottom = false;
};

datablock ParticleData( EMPMortarCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/ELFBeam";
   colors[0]     	= "0.0 0.0 0.9 0.7";
   colors[1]     	= "0.0 0.0 0.5 0.3";
   colors[2]     	= "0.0 0.0 0.3 0.0";
   sizes[0]      	= 4.0;
   sizes[1]      	= 8.0;
   sizes[2]      	= 9.0;
   times[0]      	= 0.0;
   times[1]      	= 0.5;
   times[2]      	= 1.0;
};

datablock ParticleEmitterData( EMPMortarCrescentEmitter )
{
	ejectionPeriodMS = 25;
	periodVarianceMS = 0;
	ejectionVelocity = 40;
	velocityVariance = 5.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 80;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvances = false;
	orientParticles  = true;
	lifetimeMS       = 200;
	particles = "EMPMortarCrescentParticle";
};

datablock ParticleData(EMPMortarExplosionSmoke)
{
	dragCoeffiecient     = 0.4;
	gravityCoefficient   = -0.30;   // rises slowly
	inheritedVelFactor   = 0.025;

	lifetimeMS           = 1250;
	lifetimeVarianceMS   = 500;

	textureName          = "particleTest";

	useInvAlpha =  true;
	spinRandomMin = -100.0;
	spinRandomMax =  100.0;

	textureName = "special/Smoke/bigSmoke";

	colors[0]     = "0.0 0.0 0.9 0.0";
	colors[1]     = "0.0 0.0 0.5 0.5";
	colors[2]     = "0.0 0.0 0.3 0.5";
	colors[3]     = "0.0 0.0 0.1 0.0";
	sizes[0]      = 5.0;
	sizes[1]      = 6.0;
	sizes[2]      = 10.0;
	sizes[3]      = 12.0;
	times[0]      = 0.0;
	times[1]      = 0.333;
	times[2]      = 0.666;
	times[3]      = 1.0;
};

datablock ParticleEmitterData(EMPMortarExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 8.0;


   ejectionVelocity = 1.25;
   velocityVariance = 1.2;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "EMPMortarExplosionSmoke";

};

datablock ExplosionData(EMPMortarSubExplosion1)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   delayMS = 100;
   offset = 5.0;
   playSpeed = 1.5;
   sizes[0] = "0.75 0.75 0.75";
   sizes[1] = "0.75 0.75 0.75";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(EMPMortarSubExplosion2)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   delayMS = 50;
   offset = 5.0;
   playSpeed = 1.0;
   sizes[0] = "1.25 1.25 1.25";
   sizes[1] = "1.50 1.50 1.50";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(EMPMortarSubExplosion3)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   delayMS = 0;
   offset = 0.0;
   playSpeed = 0.7;
   sizes[0] = "2.25 2.25 2.25";
   sizes[1] = "2.75 2.75 2.75";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(EMPMortarExplosion)
{
	soundProfile   		= MortarExplosionSound;
	shockwave 		= EMPMortarShockwave;
	shockwaveOnTerrain 	= true;
	subExplosion[0] 	= EMPMortarSubExplosion1;
	subExplosion[1] 	= EMPMortarSubExplosion2;
	subExplosion[2] 	= EMPMortarSubExplosion3;
	emitter[0] 		= EMPMortarExplosionSmokeEmitter;
	emitter[1] 		= EMPMortarCrescentEmitter;
	shakeCamera 		= true;
	camShakeFreq 		= "2.0 2.0 2.0";
	camShakeAmp 		= "65.0 65.0 65.0";
	camShakeDuration 	= 1.3;
	camShakeRadius 		= 40.0;
};

datablock LinearProjectileData(EMPEmplacementProjectile)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 1.2;
   hasDamageRadius     = true;
   indirectDamage      = 0.30;
   damageRadius        = 12.0;
   radiusDamageType    = $DamageType::MissileTurret;
   kickBackStrength    = 7000;

   sound 				= discProjectileSound;
   explosion           = "EMPMortarExplosion";
   underwaterExplosion = "EMPMortarExplosion";
   splash              = DiscSplash;

   dryVelocity       = 220;
   wetVelocity       = 170;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 7.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1000;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.1 0.1 0.4";
};

datablock ShapeBaseImageData(EmplacementTurretBarrel)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   mountPoint = 1;

   projectile = EMPEmplacementProjectile;
   projectileType = LinearProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 60.00;
   minEnergy = 60.00;

   projectileSpread = 5.0 / 1000.0;

   // Turret parameters
   activationMS      = 4000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 280;
   degPerSecPhi      = 280;
   attackRadius      = 75;

   // State transitions
   stateName[0]                  = "Activate";
   stateTransitionOnNotLoaded[0] = "Dead";
   stateTransitionOnLoaded[0]    = "ActivateReady";

   stateName[1]                  = "ActivateReady";
   stateSequence[1]              = "Activate";
   stateSound[1]                 = AssaultTurretActivateSound;
   stateTimeoutValue[1]          = 1;
   stateTransitionOnTimeout[1]   = "Ready";
   stateTransitionOnNotLoaded[1] = "Deactivate";

   stateName[2]                    = "Ready";
   stateTransitionOnNotLoaded[2]   = "Deactivate";
   stateTransitionOnNoAmmo[2]      = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3]                = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3]        = 0.2;
   stateFire[3]                = true;
   stateRecoil[3]              = LightRecoil;
   stateAllowImageChange[3]    = false;
   stateSequence[3]            = "Fire";
   stateSound[3]               = ESTV5TurretFireSound;
   stateScript[3]              = "onFire";

   stateName[4]                 = "Reload";
   stateTimeoutValue[4]         = 0.5;
   stateAllowImageChange[4]     = false;
   stateSequence[4]             = "Reload";
   stateTransitionOnTimeout[4]  = "Ready";
   stateTransitionOnNoAmmo[4]   = "NoAmmo";

   stateName[5]                = "Deactivate";
   stateDirection[5]           = false;
   stateSequence[5]            = "Activate";
   stateTimeoutValue[5]        = 1;
   stateTransitionOnLoaded[5]  = "ActivateReady";
   stateTransitionOnTimeout[5] = "Dead";

   stateName[6]               = "Dead";
   stateTransitionOnLoaded[6] = "ActivateReady";
   stateTransitionOnTriggerDown[6] = "DryFire";

   stateName[7]       = "DryFire";
   stateSound[7]      = AssaultMortarDryFireSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8]                      = "NoAmmo";
   stateTransitionOnAmmo[8]          = "Reload";
   stateSequence[8]                  = "NoAmmo";
   stateTransitionOnTriggerDown[8]   = "DryFire";
};


//================================================================================ Turret Functions
//	Turret Code

function EmplacementBase::onAdd(%this, %obj)
{
	Parent::onAdd(%this, %obj);
	%turret = TurretData::create(EmplacementTurret);
	MissionCleanup.add(%turret);
   	%obj.mountObject(%turret, 0);
   	%turret.mountImage(EmplacementTurretBarrel,2);
   	%obj.turretObject = %turret;
	%turret.vehicleMounted = %obj;
	%turret.setAutoFire(false);
	setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
	%this.schedule(100, "PowerCheck", %obj);
}

function EmplacementBase::PowerCheck(%this, %obj)
{
	InitContainerRadiusSearch(%obj.getPosition(), 20, $TypeMasks::StaticShapeObjectType);
	%foundinv = false;
	while((%found = containerSearchNext()) != 0)
	{
		%foundName = %found.getDataBlock().getName();
		if( (%foundName $= DeployedStationInventory) )
		{
			%foundinv = true;
			break;
		}
	}
	if(%foundinv)
	{
		%obj.setSelfPowered();
	}
	else
	{
		%obj.clearSelfPowered();
	}
	%this.schedule(500, "PowerCheck", %obj);
}


function EmplacementTurret::onGainPowerEnabled(%data, %obj)
{
   Parent::onGainPowerEnabled(%data, %obj);
}

function EmplacementTurret::onLosePowerDisabled(%data, %obj)
{
   	Parent::onLosePowerDisabled(%data, %obj);
	if(%obj.bomber)
	{
		%player = %obj.bomber;
		%armour = %player.getDataBlock();
		%player.doDismount(%player, true);
	}
}

function EmplacementBase::onDamage(%this, %obj)
{
}

function EmplacementTurret::damageObject(%this, %damageObj, %projectile, %amount, %damageType)
{
	%vehicle = %damageObj.getObjectMount();
	%vehicle.getDataBlock().damageObject(%vehicle, %projectile, %amount, %damageType);
}

function EmplacementTurret::playerMounted(%data, %obj, %player, %node)
{
	%turret = %obj;
	%turret.team = %player.team;
	%player.vehicleTurret = %obj;
	%player.setTransform("0 0 0 0 0 1 0");
	%player.lastWeapon = %player.getMountedImage($WeaponSlot);
	%player.unmountImage($WeaponSlot);
	%turret.bomber = %player;
	$bWeaponActive = 0;
	%obj.selectedWeapon = 1;
	commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
	setTargetSensorGroup(%turret.getTarget(), %player.client.getSensorGroup());
	setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
	commandToClient(%player.client, 'setHudMode', 'Pilot', "Emplacement", %node);
}

function EmplacementTurret::playerDismount(%data, %obj)
{
	%obj.fireTrigger = 0;
	%obj.setImageTrigger(2, false);
	%client = %obj.getControllingClient();
	%client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
	%client.player.mountVehicle = false;
	%turret.team = 0;
	setTargetSensorGroup(%obj.getTarget(), 0);
	setTargetNeverVisMask(%obj.getTarget(), 0xffffffff);
}

function EmplacementTurret::onTrigger(%data, %obj, %trigger, %state)
{

	%client = %obj.getControllingClient();
	%player = %client.player;
	%vehicle = %client.piloting;

	if (%trigger != 3)
	{
		switch (%state)
		{
			case 0:
				%obj.fireWeapon = false;
				%obj.setImageTrigger(2, false);
			case 1:
				%obj.fireWeapon = true;
				%obj.setImageTrigger(2, true);
		}
	}
}

function EmplacementTurretBarrel::onTriggerDown(%this, %obj, %slot)
{
   //%obj.schedule(300, "setImageTrigger", 3, true);
}

function EmplacementTurretBarrel::onTriggerUp(%this, %obj, %slot)
{
   //%obj.schedule(400, "setImageTrigger", 3, false);
}

function EmplacementTurretBarrel::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}